-- UIErrorsFrame:AddMessage( "msg" ,0,1,.5,1,2 )
-- string.find( UnitDebuff("target",i),sDebuffName )
-- DEFAULT_CHAT_FRAME:AddMessage("woot!")
-- DEFAULT_CHAT_FRAMEScrollToBottom()


Banker = {
	VERSION = 1
}



-- Initialize the variables
local Server = GetRealmName();

CharRecords = {};
CharRecords[Server] = {};
CharRecords[Server][UnitName("player")] = {};

Inventory = {};
Inventory[Server] = {};
Inventory[Server][UnitName("player")] = {};

est_mail = -2








Banker.OnLoad = function()
   this:RegisterEvent("BANKFRAME_CLOSED");
   this:RegisterEvent("BANKFRAME_OPENED");

   this:RegisterEvent("PLAYERBANKBAGSLOTS_CHANGED");
   this:RegisterEvent("PLAYERBANKSLOTS_CHANGED");

   this:RegisterEvent("UNIT_INVENTORY_CHANGED");

   this:RegisterEvent("BAG_CLOSED");
   this:RegisterEvent("BAG_OPEN");
   this:RegisterEvent("BAG_UPDATE");
   this:RegisterEvent("BAG_UPDATE_COOLDOWN");
   
   this:RegisterEvent("LOOT_CLOSED");
   this:RegisterEvent("LOOT_OPENED");
   this:RegisterEvent("LOOT_SLOT_CLEARED");

   this:RegisterEvent("ITEM_PUSH");
   this:RegisterEvent("TRADE_PLAYER_ITEM_CHANGED");

   this:RegisterEvent("TRADE_PLAYER_ITEM_CHANGED");
   this:RegisterEvent("TRADE_PLAYER_ITEM_CHANGED");

   this:RegisterEvent("PLAYER_LEAVING_WORLD");
   this:RegisterEvent("PLAYER_CAMPING");

   this:RegisterEvent("MAIL_CLOSED");
   this:RegisterEvent("MAIL_SHOW");

   est_mail = -1

   BankerLoadTime = GetTime()
end












Banker.OnEvent = function(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
  if event=="BANKFRAME_CLOSED" and ( GetInventoryItemLink("player", 40) or GetContainerItemLink(5,1) or GetContainerItemLink(6,1) ) and ( not BankerDelay or GetTime()-BankerDelay>1 ) then
    UpdateBata()
    BankerDelay=GetTime()
    
    
  elseif event=="MAIL_CLOSED" then
	  est_mail = GetInboxNumItems()
    if GetInboxNumItems()>0 and xtimer("echoMailCount",20) then
      dprint(GetInboxNumItems().." items in the mailbox")
    end
    UpdateMailRecords()
    
    
	elseif UnitLevel("player")>0 and ( event=="PLAYER_LEAVING_WORLD" or event=="PLAYER_CAMPING" or ( not CharRecordDelay or GetTime()-CharRecordDelay>60*60 ) ) and GetTime()-BankerLoadTime>8 then
    SaveCharacterRecords()	
    
    
  end 
end








Banker.OnUpdate = function ()
  if GetInboxNumItems()~=r_mailcount then
	
	  if GetInboxNumItems() and r_mailcount then
	    dprint( r_mailcount .. " > " .. GetInboxNumItems() )
		elseif GetInboxNumItems() then
		  dprint( "nil" .. " > " .. GetInboxNumItems() )
		else
		  dprint( "mail count error" )
		end
	  r_mailcount = GetInboxNumItems()
	end
end












































function SaveCharacterRecords()
  local GammaList = UnitLevel("player") .. " " .. UnitRace("player") .. " " .. UnitClass("player") .. "  "..date().."  "
  
  if est_mail then
    GammaList = GammaList .. " m: " .. est_mail
  else
    dprint("est_mail variable does not exists!")
  end
  
  if not CharRecords then CharRecords = {} end
  if not CharRecords[Server] then CharRecords[Server] = {} end
  if not CharRecords[Server][UnitName("player")] then CharRecords[Server][UnitName("player")] = {} end

  CharRecords[Server][UnitName("player")] = GammaList
  CharRecordDelay = GetTime()
  DEFAULT_CHAT_FRAMEScrollToBottom()
  DEFAULT_CHAT_FRAME:AddMessage( "[CharRecord][" .. Server .. "][" .. UnitName("player") .. "] Saved @ " .. date() .. "  " .. est_mail ,10/16,15/16,16/16)
	--dprint(GammaList)
end
























function UpdateMailRecords()
  if not Inventory                             then Inventory = {} end
  if not Inventory[Server]                     then Inventory[Server] = {} end
  if not Inventory[Server][UnitName("player")] then Inventory[Server][UnitName("player")] = {} end
  
         Inventory[Server][UnitName("player")]["Mail"] = est_mail
         
  UIErrorsFrame:AddMessage( "Mail Records Updated <"..est_mail..">" ,0,.5,1, 1,2 )
end














function RecoverCharRecord()
  if ( not CharRecords ) or ( not CharRecords[GetRealmName()] ) or ( not CharRecords[GetRealmName()][UnitName("player")] ) then return end

	return CharRecords[GetRealmName()][UnitName("player")] 
end


function CharRecordMail()
  theCharRecord = RecoverCharRecord()
	if theCharRecord and strfind(theCharRecord,"\*") then
	  mailRecord = strsub( theCharRecord , strfind(theCharRecord,"\*")-1 )
		mailRecord = strsub( mailRecord , 4 )
		return mailRecord
	end 
	return -1 
end


























--- Inventory[Server][UnitName("player")]

function UpdateBata()
  if not( GetInventoryItemLink("player", 40) or GetContainerItemLink(5,1) ) then
    DEFAULT_CHAT_FRAMEScrollToBottom()
    DEFAULT_CHAT_FRAME:AddMessage("Bank Window Must Be Open" ,1,0,0)
    return nil
  end

  local BataList = {};
  local BagSizes = {};
  local totalBags = 0;
  banker_freebagslots = 0;
  smallBagCount = 0;

-- All Containers --

  for bag=0,12 do

    if GetContainerNumSlots(bag)>0 then
      totalBags = totalBags+1
      if not BagSizes[GetContainerNumSlots(bag).." slot"] then
        BagSizes[GetContainerNumSlots(bag).." slot"] = 1
      elseif BagSizes[GetContainerNumSlots(bag).." slot"] then
        BagSizes[GetContainerNumSlots(bag).." slot"] = BagSizes[GetContainerNumSlots(bag).." slot"]+1
      end
      if GetContainerNumSlots(bag)<16 then
        smallBagCount = smallBagCount + 1
      end
    end

    for slot=1,GetContainerNumSlots(bag) do
      if ( GetContainerItemLink(bag,slot) ) then

        local MyItemName = string.sub( GetContainerItemLink(bag,slot) , string.find(GetContainerItemLink(bag,slot),"|h")+3 , -6)
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bag,slot)
        if BataList[MyItemName] then
          BataList[MyItemName] = BataList[MyItemName] + itemCount
        else
          BataList[MyItemName] = itemCount
        end
			else
			  banker_freebagslots = banker_freebagslots + 1;
      end
    end
  end







-- Bank Items --

  for b_slot=40,67 do
    if GetInventoryItemLink("player", b_slot) then

      MyItemName = string.sub( GetInventoryItemLink("player",b_slot) , string.find(GetInventoryItemLink("player",b_slot),"|h")+3 , -6)
      itemCount = GetInventoryItemCount("player", b_slot)

        if BataList[MyItemName] then
          BataList[MyItemName] = BataList[MyItemName] + itemCount
        else
          BataList[MyItemName] = itemCount
        end
			else
			  banker_freebagslots = banker_freebagslots + 1;
    end
		
  end





--[[
  echo( totalBags )
  for k,v in pairs(BagSizes) do
    echo( k .. " " .. v )
  end
]]--

  if smallBagCount==0 then
    smallBagCount=nil
  end



  if UnitLevel("player")>0 then
    local BataList = {
      Level=UnitLevel("player"),
      Class=UnitClass("player"),
			Date=date(),
      Items=BataList,
      Bags=BagSizes,
      SmallBags=smallBagCount,
      Gold = floor(GetMoney())/10000,
			Mail = est_mail,
			FreeSlots = banker_freebagslots,
    }
    if not Inventory then Inventory = {} end
    if not Inventory[Server] then Inventory[Server] = {} end
    if not Inventory[Server][UnitName("player")] then Inventory[Server][UnitName("player")] = {} end
    Inventory[Server][UnitName("player")] = BataList
  end


  

  BankerDelay=GetTime()
  DEFAULT_CHAT_FRAMEScrollToBottom()
  DEFAULT_CHAT_FRAME:AddMessage( "[Inventory][" .. Server .. "][" .. UnitName("player") .. "] Saved @ " .. date() .. "   [" .. banker_freebagslots .. "]" ,10/16,15/16,16/16)
end

















-- DEFAULT_CHAT_FRAMEScrollToBottom()
-- GetInventoryItemLink("player", b_slot)
-- DEFAULT_CHAT_FRAME:AddMessage( tempbag[bag][slot] )






-- copy'd from _OOM\Tools.lua
dprint = function(...)
  DEFAULT_CHAT_FRAME:AddMessage(...)
  DEFAULT_CHAT_FRAMEScrollToBottom() 
end










--AddOns\_OOM\Tools.lua
function DEFAULT_CHAT_FRAMEScrollToBottom()
  if xtimer("ScrollToBottom",20) then
    DEFAULT_CHAT_FRAME:ScrollToBottom() 
    ChatRefresh = GetTime()
  else
    DEFAULT_CHAT_FRAME:ScrollDown() 
    ChatRefresh = GetTime()
  end
end
























function BankerGold()
  goldsum = 0
  for key1,val1 in pairs( Inventory[GetRealmName()] ) do
    dprint( key1 .." has "..ColorText(1,1,0).. Inventory[GetRealmName()][key1]["Gold"] )
    goldsum = goldsum + Inventory[GetRealmName()][key1]["Gold"]
  end 
  dprint( "Total Gold: "..ColorText(1,1,0).. goldsum ) 
end


















--prints list of items in bank that are tradable
function nonSoulBoundBank()
  
end
